/* $Id: create.c 11 2023-04-25 07:27:30Z nishi $ */
#include <swcli/create.h>

#include <swcli/api.h>
#include <swcli/util.h>

#include <cjson/cJSON.h>

#include <sys/stat.h>
#include <pwd.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>

extern int argc;
extern char** argv;

void swcli_create(){
	if(argc < 3){
		fprintf(stderr, "%s: Repository name required\n", argv[0]);
		exit(1);
	}
	struct passwd* pwd = getpwuid(getuid());
	char* path = sstrcat(pwd->pw_dir, "/.swcli-token");
	if(access(path, F_OK) != 0){
		fprintf(stderr, "%s: Run `%s login <URL>` to login. You haven't loginned yet.\n", argv[0], argv[0]);
		free(path);
		exit(1);
	}
	free(path);
	int size = 1;
	path = sstrcat(pwd->pw_dir, "/.swcli-token");
	struct stat s;
	stat(path, &s);
	size += s.st_size;
	FILE* f = fopen(path, "r");
	char* token = malloc(s.st_size + 1);
	token[s.st_size] = 0;
	fread(token, s.st_size, 1, f);
	fclose(f);
	free(path);
	size += strlen(argv[argc - 1]);
	char* login = malloc(size + 1);
	login[size] = 0;
	strcpy(login, token);
	login[s.st_size] = ':';
	strcpy(login + s.st_size + 1, argv[argc - 1]);
	path = sstrcat(pwd->pw_dir, "/.swcli-url");
	stat(path, &s);
	char* entry = malloc(s.st_size + 1);
	entry[s.st_size] = 0;
	f = fopen(path, "r");
	fread(entry, s.st_size, 1, f);
	fclose(f);
	free(path);
	char* url = sstrcat(entry, "/v1/repo/create");
	cJSON* result = swcli_api(url, login);
	free(login);
	free(url);
	free(entry);
	if(result == NULL){
		exit(1);
	}else{
		printf("%s: Repository created successfully.\n", argv[0]);
		cJSON_Delete(result);
	}
}
