/* $Id: logout.c 11 2023-04-25 07:27:30Z nishi $ */
#include <swcli/logout.h>

#include <swcli/api.h>
#include <swcli/util.h>

#include <cjson/cJSON.h>

#include <pwd.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <sys/stat.h>

extern int argc;
extern char** argv;

void swcli_logout(){
	struct passwd* pwd = getpwuid(getuid());
	char* path = sstrcat(pwd->pw_dir, "/.swcli-token");
	struct stat s;
	if(stat(path, &s) != 0){
		fprintf(stderr, "%s: You haven't loginned yet.\n", argv[0]);
		exit(1);
	}
	char* token = malloc(s.st_size + 1);
	token[s.st_size] = 0;
	FILE* f = fopen(path, "r");
	fread(token, s.st_size, 1, f);
	fclose(f);
	free(path);
	path = sstrcat(pwd->pw_dir, "/.swcli-url");
	stat(path, &s);
	char* entry = malloc(s.st_size + 1);
	entry[s.st_size] = 0;
	f = fopen(path, "r");
	fread(entry, s.st_size, 1, f);
	fclose(f);
	free(path);
	char* url = sstrcat(entry, "/v1/logout");
	free(entry);
	cJSON* result = swcli_api(url, token);
	free(token);
	free(url);
	if(result == NULL){
		exit(1);
	}else{
		path = sstrcat(pwd->pw_dir, "/.swcli-token");
		remove(path);
		free(path);
		path = sstrcat(pwd->pw_dir, "/.swcli-url");
		remove(path);
		free(path);
		path = sstrcat(pwd->pw_dir, "/.swcli-username");
		remove(path);
		free(path);
		fprintf(stderr, "%s: Logout successful.\n", argv[0]);
	}
}
